#ifndef LRNN_H

#define LRNN_H

#include<iostream>
#include<vector>
#include<cmath>
#include"rand.h"
#include<cfloat>
#include<map>

#include"network.h"
#include "rnn.h"

using namespace std;

//Leaky rnn
struct LRNN: public RNN
{
 vector<long double> alpha,prev_alpha,sigmalpha,prev_sigmalpha;//model is V(t+1)=V(t)-sigmoid(alpha).V(t)+W.act(t)
 virtual void computeNextAct();
 virtual void initWeights();
 virtual void Setup();
 virtual void saveTauParams();virtual void restoreTauParams();
 //Functions that are to be fed to the learning algorithm.
 //Connections between model and learning algorithm are handled
 //by functions in model.h
 void ApplyDFDV(vector<long double>&dv);
 void MultiplyRightDFDV(vector<long double>&dv);
 void DFDTheta(vector<Vector>&grad);
 function<void()> SaveState();
 void UpdateAct(const vector<long double>&dv);
 virtual void setTransparams(vector<vector<long double*>>&transparams,vector<vector<long double>>&transdiagregul); 
};

#endif /* end of include guard: LRNN_H */
